#ifndef FLIGHTSPAINTLAYER_H
#define FLIGHTSPAINTLAYER_H

#include <marble/MarbleWidget.h>
#include <marble/MarbleMap.h>
//#include <marble/MarbleModel.h>
#include <marble/GeoPainter.h>
#include <marble/LayerInterface.h>


#include "flights/flightsmodel.h"
class FlightsModel;



using namespace Marble;

class FlightsPaintLayer : public QObject, public LayerInterface
{
   // Q_OBJECT
public:
    enum MODE{
        MINI_MODE,
        NORMAL_MODE
    };
    // Constructor
    FlightsPaintLayer(MarbleWidget* widget, MODE min_mode);


    int map_mode;


    FlightsModel *flightsModel;

    // Implemented from LayerInterface
    virtual QStringList renderPosition() const;

    // Implemented from LayerInterface
    virtual bool render( GeoPainter *painter, ViewportParams *viewport,
                        const QString& renderPos = "NONE", GeoSceneLayer * layer = 0 );

    // Overriding QObject
    // TODO Make this work is key
    virtual bool eventFilter(QObject *obj, QEvent *event);


    void register_flights_model(FlightsModel *fmod);

private:
    MarbleWidget* m_widget;

    int m_index;
};


#endif // FLIGHTSPAINTLAYER_H
